:: Use the Files.lst Generator to automate the creation of a Files.lst
:: for No$GBA. This allows you to load games from various directories
:: without having to browse. Files.lst Generator will append an existing
:: Files.lst if there is one in the same directory, allowing you fine control
:: over the order of the files listed. When both NDS and GBA ROMs are parsed
:: at the same time, NDS ROMs get listed first, followed by the GBA ROMs.
:: Only files with .nds or .gba extensions are processed, others are ignored.
:: Rom extensions may be capital or lowercase or a mix of both.
:: Once a Files.lst is created, it is easy to modify in notepad.
:: Usage 1 - Put Files.lst Generator in a ROM folder and double click it
:: Usage 2 - Drag one or multiple ROMs onto Files.lst Generator
:: Usage 3 - Drag a ROM folder onto the Files.lst Generator
:: Usage 4 - Double click Files.lst Generator (in a folder with no ROMS)
:: 	to be prompted for a single ROM or a single ROM folder
:: 	then continues with prompts until user is done

@ECHO OFF
SETLOCAL
TITLE Files.lst Generator for No$GBA
PUSHD "%~dp0"
SET BDIR=%~dp0
IF "%~1"=="" GOTO click
IF "%~x1"=="" SET ROMS=%~f1
IF "%~x1"=="" CALL :fold %ROMS%
GOTO drag

:drag
IF /I "%~x1"==".nds" ECHO %~nx1^>"%~f1" >>Files.lst
IF /I "%~x1"==".gba" ECHO %~nx1^>"%~f1" >>gba.lst
IF "%~1"=="" GOTO done
SHIFT & GOTO drag

:click
FOR %%g IN (*.nds) DO ECHO %%g^>"%~dp0%%g">>Files.lst
FOR %%g IN (*.gba) DO ECHO %%g^>"%~dp0%%g">>Files.lst
IF /I EXIST "*.nds" GOTO done
IF /I EXIST "*.gba" GOTO done
GOTO ask

:ask
ECHO.  & ECHO No game ROMs were found in
ECHO %~dp0  & ECHO.
ECHO Where are your NDS and/or GBA ROMs?
ECHO (Type a path or drag and drop here, then press Enter)
ECHO.
SET /P ROMS=
CALL :what %ROMS%
GOTO done

:what
IF "%~x1"=="" GOTO fold
IF /I "%~x1"==".nds" ECHO %~nx1^>"%~f1" >>Files.lst
IF /I "%~x1"==".gba" ECHO %~nx1^>"%~f1" >>Files.lst
GOTO more

:fold
PUSHD "%ROMS%"
SET ROMS=%~f1
FOR %%g IN (*.nds) DO ECHO %%g^>"%ROMS%\%%g">>Files.lst
FOR %%g IN (*.gba) DO ECHO %%g^>"%ROMS%\%%g">>Files.lst
TYPE Files.lst >> "%~dp0"Files.lst
DEL Files.lst
ECHO.  & ECHO Added ROMs from...  & ECHO %ROMS%
POPD
GOTO more

:more
ECHO.  & ECHO To add to the list, type or drag here then press Enter
ECHO. & ECHO To finish, just push Enter  
SET ROMS=
SET /P ROMS=
IF (%ROMS%)==() GOTO end
CALL :what %ROMS%
GOTO end

:eror
ECHO.  & ECHO Error - No GBA or NDS Files found
ECHO.  & ECHO A File List has not been created or altered
ECHO.  & ECHO Press any key to exit
PAUSE >nul
POPD
ENDLOCAL
GOTO end

:done
IF EXIST gba.lst (TYPE gba.lst >>Files.lst )
IF EXIST gba.lst (DEL /Q gba.lst )
IF NOT EXIST Files.lst GOTO eror
CLS
ECHO. & ECHO Your No$GBA Files List has been saved in...  & ECHO.
ECHO %BDIR%  & ECHO.  & ECHO and is named... Files.lst  & ECHO.
ECHO.  & ECHO Press any key to close this window
PAUSE >nul
POPD
ENDLOCAL

:end